# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2012-05-25.      #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generator git on tinkerforge.com                   #
#############################################################

module Tinkerforge
  # Device for sensing Rotary Potentiometer input
  class BrickletRotaryPoti < Device

    # This callback is triggered periodically with the period that is set by
    # BrickletRotaryPoti#set_position_callback_period. The parameter is the position of the
    # Rotary Potentiometer.
    # 
    # CALLBACK_POSITION is only triggered if the position has changed since the
    # last triggering.
    CALLBACK_POSITION = 13

    # This callback is triggered periodically with the period that is set by
    # BrickletRotaryPoti#set_analog_value_callback_period. The parameter is the analog value of the
    # Rotary Potentiometer.
    # 
    # CALLBACK_ANALOG_VALUE is only triggered if the position has changed since the
    # last triggering.
    CALLBACK_ANALOG_VALUE = 14

    # This callback is triggered when the threshold as set by
    # BrickletRotaryPoti#set_position_callback_threshold is reached.
    # The parameter is the position of the Rotary Potentiometer.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletRotaryPoti#set_debounce_period.
    CALLBACK_POSITION_REACHED = 15

    # This callback is triggered when the threshold as set by
    # BrickletRotaryPoti#set_analog_value_callback_threshold is reached.
    # The parameter is the analog value of the Rotary Potentiometer.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletRotaryPoti#set_debounce_period.
    CALLBACK_ANALOG_VALUE_REACHED = 16

    FUNCTION_GET_POSITION = 1 # :nodoc:
    FUNCTION_GET_ANALOG_VALUE = 2 # :nodoc:
    FUNCTION_SET_POSITION_CALLBACK_PERIOD = 3 # :nodoc:
    FUNCTION_GET_POSITION_CALLBACK_PERIOD = 4 # :nodoc:
    FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 5 # :nodoc:
    FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 6 # :nodoc:
    FUNCTION_SET_POSITION_CALLBACK_THRESHOLD = 7 # :nodoc:
    FUNCTION_GET_POSITION_CALLBACK_THRESHOLD = 8 # :nodoc:
    FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 9 # :nodoc:
    FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 10 # :nodoc:
    FUNCTION_SET_DEBOUNCE_PERIOD = 11 # :nodoc:
    FUNCTION_GET_DEBOUNCE_PERIOD = 12 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt>. This object can
    # then be added to the IP connection.
    def initialize(uid)
      super uid

      @expected_name = 'Rotary Poti Bricklet'

      @binding_version = [1, 0, 0]

      @callback_formats[CALLBACK_POSITION] = 's'
      @callback_formats[CALLBACK_ANALOG_VALUE] = 'S'
      @callback_formats[CALLBACK_POSITION_REACHED] = 's'
      @callback_formats[CALLBACK_ANALOG_VALUE_REACHED] = 'S'
    end

    # Returns the position of the Rotary Potentiometer. The value is in degree 
    # and between -150° (turned left) and 150° (turned right).
    # 
    # If you want to get the position periodically, it is recommended to use the
    # callback CALLBACK_POSITION and set the period with 
    # BrickletRotaryPoti#set_position_callback_period.
    def get_position
      send_request(FUNCTION_GET_POSITION, [], '', 2, 's')
    end

    # Returns the value as read by a 12 bit analog to digital converter.
    # The value is between 0 and 4095.
    # 
    #  .. note::
    #   The value returned by BrickletRotaryPoti#get_position is averaged over several samples
    #   to yield less noise, while BrickletRotaryPoti#get_analog_value gives back raw
    #   unfiltered analog values. The only reason to use BrickletRotaryPoti#get_analog_value is,
    #   if you need the full resolution of the analog to digital converter.
    # 
    # If you want the analog value periodically, it is recommended to use the 
    # callback CALLBACK_ANALOG_VALUE and set the period with 
    # BrickletRotaryPoti#set_analog_value_callback_period.
    def get_analog_value
      send_request(FUNCTION_GET_ANALOG_VALUE, [], '', 2, 'S')
    end

    # Sets the period in ms with which the CALLBACK_POSITION callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # CALLBACK_POSITION is only triggered if the position has changed since the
    # last triggering.
    # 
    # The default value is 0.
    def set_position_callback_period(period)
      send_request(FUNCTION_SET_POSITION_CALLBACK_PERIOD, [period], 'L', 0, '')
    end

    # Returns the period as set by BrickletRotaryPoti#set_position_callback_period.
    def get_position_callback_period
      send_request(FUNCTION_GET_POSITION_CALLBACK_PERIOD, [], '', 4, 'L')
    end

    # Sets the period in ms with which the CALLBACK_ANALOG_VALUE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # CALLBACK_ANALOG_VALUE is only triggered if the analog value has changed since the
    # last triggering.
    # 
    # The default value is 0.
    def set_analog_value_callback_period(period)
      send_request(FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, [period], 'L', 0, '')
    end

    # Returns the period as set by BrickletRotaryPoti#set_analog_value_callback_period.
    def get_analog_value_callback_period
      send_request(FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, [], '', 4, 'L')
    end

    # Sets the thresholds for the CALLBACK_POSITION_REACHED callback. 
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off."
    #  "'o'",    "Callback is triggered when the position is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the position is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the position is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the position is greater than the min value (max is ignored)"
    # 
    # The default value is ('x', 0, 0).
    def set_position_callback_threshold(option, min, max)
      send_request(FUNCTION_SET_POSITION_CALLBACK_THRESHOLD, [option, min, max], 'k s s', 0, '')
    end

    # Returns the threshold as set by BrickletRotaryPoti#set_position_callback_threshold.
    def get_position_callback_threshold
      send_request(FUNCTION_GET_POSITION_CALLBACK_THRESHOLD, [], '', 5, 'k s s')
    end

    # Sets the thresholds for the CALLBACK_ANALOG_VALUE_REACHED callback. 
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off."
    #  "'o'",    "Callback is triggered when the position is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the position is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the position is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the position is greater than the min value (max is ignored)"
    # 
    # The default value is ('x', 0, 0).
    def set_analog_value_callback_threshold(option, min, max)
      send_request(FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, [option, min, max], 'k S S', 0, '')
    end

    # Returns the threshold as set by BrickletRotaryPoti#set_analog_value_callback_threshold.
    def get_analog_value_callback_threshold
      send_request(FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, [], '', 5, 'k S S')
    end

    # Sets the period in ms with which the threshold callbacks
    # 
    #  CALLBACK_POSITION_REACHED, CALLBACK_ANALOG_VALUE_REACHED
    # 
    # are triggered, if the thresholds
    # 
    #  BrickletRotaryPoti#set_position_callback_threshold, BrickletRotaryPoti#set_analog_value_callback_threshold
    # 
    # keep being reached.
    # 
    # The default value is 100.
    def set_debounce_period(debounce)
      send_request(FUNCTION_SET_DEBOUNCE_PERIOD, [debounce], 'L', 0, '')
    end

    # Returns the debounce period as set by BrickletRotaryPoti#set_debounce_period.
    def get_debounce_period
      send_request(FUNCTION_GET_DEBOUNCE_PERIOD, [], '', 4, 'L')
    end

    # Registers a callback with ID <tt>cb</tt> to the block <tt>block</tt>.
    def register_callback(cb, &block)
      callback = block
      @registered_callbacks[cb] = callback
    end
  end
end
